# lists all code files in the codebase 
list_files() {
    find $(pwd) -type f \
        \( -name "*.py" -o -name "*.c" -o -name "*.cpp" -o -name "*.java" -o -name "*.scala" -o -name "*.rs" -o -name "*.go" -o -name "*.js" \) \
        ! -path "*\/test\/*" ! -path "*\/tests\/*" ! -path "*\/testing\/*" \
        ! -name "*test*" ! -name "*test.*" ! -name "test*" ! -name "*.test" ! -name "*.test.*"
}